#include <iostream.h>
#include "ds9tk.h"

extern "C" {
  int Blt_Init(Tcl_Interp*);
  int Ast_Init(Tcl_Interp*);
  int Saotk_Init(Tcl_Interp*);
  int Tclxpa_Init(Tcl_Interp*);
#ifndef _WIN32
  int Iis_Init(Tcl_Interp*);
#endif
}

// just so that mktclapp will see it
int Et_AppInit();

extern "C" {
int Et_AppInit(Tcl_Interp *interp)
{
  if (Blt_Init(interp) == TCL_ERROR)
    return TCL_ERROR;
  Tcl_StaticPackage (interp, "BLT", Blt_Init, (Tcl_PackageInitProc*)NULL);

  if (Ast_Init(interp) == TCL_ERROR)
    return TCL_ERROR;
  Tcl_StaticPackage (interp, "Ast", Ast_Init, (Tcl_PackageInitProc*)NULL);

  if (Saotk_Init(interp) == TCL_ERROR)
    return TCL_ERROR;
  Tcl_StaticPackage (interp, "saotk", Saotk_Init,(Tcl_PackageInitProc*)NULL);

  if (Tclxpa_Init(interp) == TCL_ERROR)
    return TCL_ERROR;
  Tcl_StaticPackage (interp, "tclxpa", Tclxpa_Init,(Tcl_PackageInitProc*)NULL);

#ifndef _WIN32
  if (Iis_Init(interp) == TCL_ERROR)
    return TCL_ERROR;
  Tcl_StaticPackage (interp, "iis", Iis_Init, (Tcl_PackageInitProc*)NULL);
#endif

  return TCL_OK;
}
}

int main(int argc, char** argv)
{
  ios::sync_with_stdio();    // sync C++ io calls with C io calls
  Et_Init(argc, argv);
  return 0;
}

