package provide DS9 1.0

proc RASSDialog {} {
    global rass
    global ds9
    global menu
    global current

    if [winfo exists $rass(top)] {
	return
    }

    set w $rass(top)
    set title "RASS Server"

    # create the window

    toplevel $w -colormap $ds9(main)
    wm title $w $title
    wm iconname $w $title
    wm group $w $ds9(top)
    wm protocol $w WM_DELETE_WINDOW RASSDestroyDialog

    # menu

    $w configure -menu $rass(mb)
    menu $rass(mb) -tearoff 0
    $rass(mb) add cascade -label File -menu $rass(mb).file
    $rass(mb) add cascade -label "RASS Svr" -menu $rass(mb).server
    $rass(mb) add cascade -label "Name Svr" -menu $rass(mb).name
    $rass(mb) add cascade -label "Coord" -menu $rass(mb).coord
    $rass(mb) add cascade -label "Survey" -menu $rass(mb).survey
    $rass(mb) add cascade -label "Prefs" -menu $rass(mb).prefs

    menu $rass(mb).file -tearoff 0 -selectcolor $menu(selectcolor)
    $rass(mb).file add command -label "Update from Current Frame" \
	-command UpdateRASSDialog
    $rass(mb).file add command -label Clear -command RASSClearDialog
    $rass(mb).file add separator
    $rass(mb).file add command -label Acknowledgement -command RASSAck
    $rass(mb).file add separator
    $rass(mb).file add command -label Close -command RASSDestroyDialog

    menu $rass(mb).server -tearoff 0 -selectcolor $menu(selectcolor)
    $rass(mb).server add radiobutton -label "RASS@MPE" \
	-variable rass(server) -value mpe

    menu $rass(mb).name -tearoff 0 -selectcolor $menu(selectcolor)
    $rass(mb).name add radiobutton -label "NED@SAO" \
	-variable nsvr(server) -value ned-sao
    $rass(mb).name add radiobutton -label "NED@ESO" \
	-variable nsvr(server) -value ned-eso
    $rass(mb).name add radiobutton -label "SIMBAD@SAO" \
	-variable nsvr(server) -value simbad-sao
    $rass(mb).name add radiobutton -label "SIMBAD@ESO" \
	-variable nsvr(server) -value simbad-eso

    menu $rass(mb).coord -tearoff 0 -selectcolor $menu(selectcolor)
    $rass(mb).coord add radiobutton -label "Equatorial B1950" \
	-variable rass(system) -value fk4 -command RASSCoordDialog
    $rass(mb).coord add radiobutton -label "Equatorial J2000" \
	-variable rass(system) -value fk5 -command RASSCoordDialog
    $rass(mb).coord add radiobutton -label "ICRS" \
	-variable rass(system) -value icrs -command RASSCoordDialog
    $rass(mb).coord add radiobutton -label "Galactic" \
	-variable rass(system) -value galactic -command RASSCoordDialog
    $rass(mb).coord add radiobutton -label "Ecliptic" \
	-variable rass(system) -value ecliptic -command RASSCoordDialog

    menu $rass(mb).survey -tearoff 0 -selectcolor $menu(selectcolor)
    $rass(mb).survey add radiobutton -label "Broad Band (0.1-2.4 keV)" \
	-variable rass(survey) -value broad
    $rass(mb).survey add radiobutton -label "Hard  Band (0.1-0.4 keV)" \
	-variable rass(survey) -value hard
    $rass(mb).survey add radiobutton -label "Soft  Band (0.5-2.0 keV)" \
	-variable rass(survey) -value soft
    $rass(mb).survey add separator
    $rass(mb).survey add radiobutton -label "Raw Data (Fits Bin Table)" \
	-variable rass(survey) -value raw

    menu $rass(mb).prefs -tearoff 0 -selectcolor $menu(selectcolor)
    $rass(mb).prefs add checkbutton -label "Save FITS on download" \
	-variable rass(save)
#    $rass(mb).prefs add checkbutton -label "Set size from Current Image" \
\#	-variable rass(updatesize)
    $rass(mb).prefs add separator
    $rass(mb).prefs add radiobutton -label "New Frame" \
	-variable rass(frame) -value new
    $rass(mb).prefs add radiobutton -label "Current Frame" \
	-variable rass(frame) -value current

    frame $w.param -relief groove -borderwidth 2
    frame $w.status -relief groove -borderwidth 2
    frame $w.buttons -relief groove -borderwidth 2
    pack $w.param $w.status $w.buttons -fill x -expand true -ipadx 4 -ipady 4

    label $w.param.nametitle -text "Name"
    entry $w.param.name -textvariable rass(name) -width 38 -relief sunken \
	-bd 2

    set rass(xname) [label $w.param.xtitle -text "" -font symbol -width 1]
    entry $w.param.x -textvariable rass(x) -width 14 -relief sunken -bd 2
    set rass(yname) [label $w.param.ytitle -text "" -font symbol -width 1]
    entry $w.param.y -textvariable rass(y) -width 14 -relief sunken -bd 2
    label $w.param.system -textvariable rass(system) \
	-width 10 -relief groove -bd 2

#    label $w.param.wtitle -text "Width"
#    entry $w.param.w -textvariable rass(width) -width 14 -relief sunken -bd 2
#    label $w.param.htitle -text "Height"
#    entry $w.param.h -textvariable rass(height) -width 14 -relief sunken -bd 2
#    label $w.param.format -textvariable rass(format) \
\#	-width 10 -relief groove -bd 2

    grid rowconfigure $w.param 0 -pad 4
    grid rowconfigure $w.param 1 -pad 4
    grid rowconfigure $w.param 2 -pad 4

    grid $w.param.nametitle -row 0 -column 0 -padx 4 -pady 1 -sticky w
    grid $w.param.name -row 0 -column 1 -columnspan 4 -pady 1 -padx 4 -sticky w

    grid $w.param.xtitle -row 1 -column 0 -padx 4 -pady 1 -sticky w
    grid $w.param.x -row 1 -column 1 -padx 4 -pady 1 -sticky w
    grid $w.param.ytitle -row 1 -column 2 -padx 4 -pady 1 -sticky w
    grid $w.param.y -row 1 -column 3 -padx 4 -pady 1 -sticky w
    grid $w.param.system -row 1 -column 4 -padx 4 -pady 1 -sticky w

#    grid $w.param.wtitle -row 2 -column 0 -padx 4 -sticky w
#    grid $w.param.w -row 2 -column 1 -padx 4 -sticky w
#    grid $w.param.htitle -row 2 -column 2 -padx 4 -sticky w
#    grid $w.param.h -row 2 -column 3 -padx 4 -sticky w
#    grid $w.param.format -row 2 -column 4 -padx 4 -sticky w

    label $w.status.item -textvariable rass(status)
    pack $w.status.item -anchor w -pady 4

    set rass(apply) \
	[button $w.buttons.apply -text "Retrieve" -command RASSApplyDialog]
    set rass(cancel) \
	[button $w.buttons.cancel -text "Cancel" -command RASSCancelDialog \
	     -state disabled]
    button $w.buttons.close -text "Close" -command RASSDestroyDialog
    pack $w.buttons.apply $w.buttons.cancel $w.buttons.close \
	-side left -padx 10 -expand true

    UpdateRASSDialog
    RASSCoordDialog
    RASSStatus {}
}

proc RASSDestroyDialog {} {
    global rass

    if {[info exists rass(token)]} {
	http::reset $rass(token)
    }
    destroy $rass(top)
    destroy $rass(mb)
}

proc RASSApplyDialog {} {
    global rass
    global nsvr
    global ds9

    # issue raw data warning

    if {$rass(survey) == "raw"} {
	if {[tk_messageBox -parent $ds9(top) -type okcancel -message "Raw Data files are very large and will take sometime to download. Do you wish to continue?"] == "cancel"} {
	    return
	}
    }

    # Name Resolution

    RASSStatus {}
    $rass(apply) configure -state disabled
    $rass(cancel) configure -state normal

    if {$rass(name) != ""} {
	RASSStatus "Looking up $rass(name)"
	set rass(x) {}
	set rass(y) {}
	set coord [NameSVR $nsvr(server) $rass(name) degrees]
	set rass(x) [lindex $coord 0]
	set rass(y) [lindex $coord 1]
	set rass(system) fk5
	RASSCoordDialog

	if {($rass(x) == "") || ($rass(y) == "")} {
	    set rass(x) {}
	    set rass(y) {}
	    RASSStatus "$rass(name) not found"

	    $rass(apply) configure -state normal
	    $rass(cancel) configure -state disabled
	    return
	}
    }

    RASSStatus "Contacting RASS Server"
    if {($rass(x) != "") && ($rass(y) != "")} {
	switch $rass(frame) {
	    new {
		set ds9(displaymode) tile
		CreateFrame
	    }
	    current {}
	}

	switch $rass(server) {
	    mpe {RASSMPE 1}
	}
    }    

    $rass(apply) configure -state normal
    $rass(cancel) configure -state disabled
}

proc RASSCancelDialog {} {
    global rass

    if {[info exists rass(token)]} {
	http::reset $rass(token)
    }

    $rass(apply) configure -state normal
    $rass(cancel) configure -state disabled
}

proc RASSCommandLine {name} {
    global rass

    set rass(name) $name
    set rass(frame) current

    RASSDialog
    RASSApplyDialog
}

proc RASSXPA {name} {
    global rass
    global nsvr
    global ds9

    set rass(name) $name

    if {$rass(name) != ""} {
	set rass(x) {}
	set rass(y) {}
	set coord [NameSVR $nsvr(server) $rass(name) degrees]
	set rass(x) [lindex $coord 0]
	set rass(y) [lindex $coord 1]
	set rass(system) fk5

	if {($rass(x) == "") || ($rass(y) == "")} {
	    set rass(x) {}
	    set rass(y) {}
	    Error "$rass(name) not found"
	    return
	}
    }

    if {($rass(x) != "") && ($rass(y) != "")} {
	switch $rass(server) {
	    mpe {RASSMPE 0}
	}
    }    
}

proc RASSStatus {message} {
    global rass

    set rass(status) "Status: $message"
}

proc RASSProgress {token totalsize currentsize} {
    if {$totalsize != 0} {
	RASSStatus "$currentsize bytes of $totalsize bytes [expr int(double($currentsize)/$totalsize*100)]%"
    } else {
	RASSStatus "$currentsize bytes"
    }
}

proc RASSClearDialog {} {
    global rass

    set rass(name) ""
    set rass(x) ""
    set rass(y) ""
    RASSStatus {}
}

proc RASSCoordDialog {} {
    global rass

    switch $rass(system) {
	fk4 -
	fk5 -
	icrs {
	    $rass(xname) configure -text "a" -font symbol
	    $rass(yname) configure -text "d" -font symbol
	}
	galactic {
	    $rass(xname) configure -text "l" \
		-font {-family times -slant italic}
	    $rass(yname) configure -text "b" \
		-font {-family times -slant italic}
	}
	ecliptic {
	    $rass(xname) configure -text "l" -font symbol
	    $rass(yname) configure -text "b" -font symbol
	}
    }
}

proc RASSMPE {verbose} {
    global rass
    global ds9
    global current

    # determine file name

    if {!$ds9(gz)} {
	tk_messageBox -parent $ds9(top) -icon info -type ok -message \
		"Sorry, but RASS requires gz compression to be available."
	return
    }

    if {$rass(save)} {
	set fn [SaveFileDialog $ds9(top) ds9(lastRASSName)]
	if {$fn == ""} {
	    return
	}
	set fn "$fn.gz"

    } else {
	if {$rass(name) != ""} {
	    set fn "$ds9(tmpdir)/$rass(name).fits.gz"
	} else {
	    set fn "$ds9(tmpdir)/rass.fits.gz"
	}
    }

    # determine product

    switch $rass(survey) {
	broad {set posfix _im1.fits.gz}
	hard {set posfix _im2.fits.gz}
	soft {set posfix _im3.fits.gz}
	raw {set posfix _bas.fits.gz}
    }

    # determine coords

    switch $rass(system) {
	fk4 {
	    set csys1 EQU
	    set equ1 1950
	}
	fk5 {
	    set csys1 EQU
	    set equ1 2000
	}
	icrs {
	    set csys1 EQU
	    set equ1 2000
	}
	galactic {
	    set csys1 GAL
	    set equ1 2000
	}
	ecliptic {
	    set csys1 ECL
	    set equ1 2000
	}
    }

    # find out which plate

    set query [http::formatQuery lwork 1\
		   lon $rass(x) lat $rass(y) \
		   rfovd .5 \
		   csys1 $csys1 equ1 $equ1]

    # send query

    if {$verbose} {
	RASSStatus "Query Server for Plate number..."
    }
    set token [http::geturl "http://www.xray.mpe.mpg.de/cgi-bin/rass-fields" \
		   -query $query]
    upvar 0 $token t
    # only grab the last 500 or so chars
    set str [string range $t(body) [expr [string length $t(body)]-500] end]

    if {![regexp {(---)*([0-9]+p)} $t(body) a b plt]} {
	if {$verbose} {
	    RASSStatus "No plate available for this coordinate"
	} else {
	    Error "No plate available for this coordinate"
	}
	return
    }

    if {$plt == ""} {
	return
    }

    if {$verbose} {
	RASSStatus "Downloading Image..."
    }
    set url "ftp://ftp.xray.mpe.mpg.de/rosat/archive/[string range $plt 0 0]00000/$plt/rs[string range $plt 0 5]n00${posfix}"

    LoadFTP $url $fn $rass(save) {}

    switch $rass(survey) {
	broad -
	hard -
	soft {
	    if {[$current(frame) has wcs equatorial]} {
		$current(frame) pan to $rass(x) $rass(y) $rass(system)
	    }
	}
	raw {}
    }
    if {$verbose} {
	RASSStatus {Done}
    }
}

proc RASSMPE0 {} {
    global rass
    global ds9

    if {$rass(save)} {
	set fn [SaveFileDialog $ds9(top) ds9(lastRASSName)]
	if {$fn == ""} {
	    return
	}

    } else {
	set fn "$ds9(tmpdir)/rass.fits"
    }

    set query [http::formatQuery \
		   lwork 1 pid0 611 \
		   lfov 1 lon $rass(x) lat $rass(y) csys1 EQU equ1 2000 \
		   lfid 0 cfid 180015p \
		   lsrv 1 \
		   lfovc 0 rfovc 55 lexpt 0 rexpt 100 \
		   lobj 0 catid 1rxs \
		   ne 1 \
		   ien0 11 cmin1 0 cmax1 10 \
		   ien1 40 cmin2 0 cmax2 6 \
		   ien2 100 cmin3 0 cmax3 4 \
		   ien3 300 \
		   nx 256 rpsz 45 xoff 0.0 yoff 0.0 \
		   gamma 1.0 icoltf 2 lcinv 0 \
		   ismtyp 0 \
		   nbmax 2 rlhthr 8 \
		   lexpc 0 lgrd 0 ipensg 2 \
		   lpht 0 lmex 0 lili 0 \
		   lps 0 ljpeg 0 lgzip 0
		   ]

    # send query

    RASSStatus "Building Image..."
    set token [http::geturl "http://www.xray.mpe.mpg.de/cgi-bin/rdb" \
		   -query $query]
    upvar 0 $token t
    if {![regexp {(.)*(/rosat/images/www/pid/)([0-9]+)} $t(body) a b c pid]} {
	RASSStatus "Error: bad returned format"
	return
    }

    # Load image

    if {$pid != ""} {
	LoadHTTP "http://www.xray.mpe.mpg.de/rosat/images/www/pid/$pid/photon_image1.fits" "$fn" $rass(save) {} RASSProgress {}
    } else {
	RASSStatus "Error: bad pid returned"
	return
    }
}

proc UpdateRASSDialog {} {
    global current
    global rass

    if {[winfo exist $rass(top)]} {
	if {$current(frame) != ""} {
	    if {[$current(frame) has wcs equatorial]} {
		set coord [$current(frame) get cursor \
			       $rass(system) degrees]
		set rass(x) [lindex $coord 0]
		set rass(y) [lindex $coord 1]

		if {$rass(updatesize)} {
		    set size [$current(frame) get fits size arcmin]
		    set rass(width) [lindex $size 0]
		    set rass(height) [lindex $size 1]
		}
	    }
	}
    }
}

proc RASSAck {} {
    global ackDialog

set msg {ROSAT Data Archive: Acknowledgement 

Please acknowledge / cite the use of the MPE ROSAT Data Archive
in your publications by the following phrase: 

"I / we have made use of the ROSAT Data Archive of the
Max-Planck-Institut fr extraterrestrische Physik (MPE)
at Garching, Germany." 
}

    set ackDialog(top) .ack
    set ackDialog(mb) .ackMB
    set ackDialog(txt) "$msg"

    SimpleTextDialog ackDialog 80 40 "Acknowledgement" insert top
}
