%{

/*
#define YYDEBUG 1
int filtdebug=1;
*/
%}

%union {
  char *s;
}
%token <s> REGION
%token <s> ROUTINE
%token <s> NAME
%token <s> NUM
%token <s> STR
%token <s> COM

%left	RANGELIST
%left	OR
%left	AND ','
%left	'|'
%left	'^'
%left 	'&'
%left	EQ NE
%left	'<' LE '>' GE
%left	SHL SHR
%left	'+' '-'
%left	'*' '/' '%'
%right	'!' '~'
%nonassoc UMINUS

%type <s> expression

%%
statement:	expression 	  {
		}
	;

expression: 
  		expression OR  expression  {}
  	|	expression ',' expression  {}
  	|	expression ';' expression  {}
  	|	expression AND expression  {}
  	|	expression '|' expression  {}
  	|	expression '^' expression  {}
  	|	expression '&' expression  {}
  	|	expression NE  expression  {}
  	|	expression EQ  expression  {}
  	|	expression GE  expression  {}
  	|	expression '>'  expression {}
  	|	expression LE  expression  {}
  	|	expression '<'  expression {}
  	|	expression SHR expression  {}
  	|	expression SHL expression  {}
  	|	expression '+' expression  {}
	|	expression '-' expression  {}
	|	expression '*' expression  {}
	|	expression '/' expression  {}
	|	expression '%' expression  {}
	|	'!' expression 		   {}
	|	'-' expression 		   {}
	|	'(' expression ')' 	   {}
	|	ROUTINE	'(' ')' 	   {}
	|	ROUTINE	'(' args ')' 	   {}
	|	REGION	'(' ')' 	   {}
	|	REGION	'(' args ')' 	   {}
	|	REGION	args 	 	   {}
	|	REGION	 	 	   {}
	|	NUM 			   {}
	|	NAME 			   {}
	|	STR 			   {}
	|	RANGELIST		   {}
	|	COM			   {}
	;

args:		args ',' args 		   {}
	|	args args 		   {}
	|	NUM 			   {}
	|	NAME 			   {}
	|	STR 			   {}
	|	ROUTINE	'(' args ')' 	   {}

%%


