#include "alloc.h"

FitsAlloc::FitsAlloc(const char* fn)
{
  parse(fn);

  if (!strcmp(pName_, "stdin") || 
      !strcmp(pName_, "STDIN") || 
      !strcmp(pName_, "-"))
    stream_ = stdin;
  else 
    // we need the 'b' for windows...
    stream_ = fopen(pName_, "rb");
}

FitsFitsAlloc::FitsFitsAlloc(const char* fn, ScanMode mode) : FitsAlloc(fn)
{
  if (stream_)
    if (mode == EXACT || pExt_ || pIndex_)
      processExact();
    else
      processRelax();
}

FitsArrAlloc::FitsArrAlloc(const char* fn) : FitsAlloc(fn)
{
  if (stream_)
    processArray();
}

FitsMosaicAlloc::FitsMosaicAlloc(const char* fn) : FitsAlloc(fn)
{
  if (stream_)
    processMosaic();
}

FitsMosaicNextAlloc::FitsMosaicNextAlloc(FitsFile* ff)
{
  processMosaicNext(ff);
}
