#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <iostream.h>
#include <strstream.h>
#include <fstream.h>

main(int argc, char* argv[])
{
  // check for args
  if (argc != 3){
    cerr << "usage: shmload key fits" << endl;
    exit(1);
  }

  // find the file
  char* fn = argv[2];
  struct stat statb;
  if (stat(fn, &statb) < 0){
    cerr << "can't find file: " << fn << endl;
    exit(1);
  }
  int fnsize = statb.st_size;
  cerr << fn << " size " << fnsize << endl;

  // calculate shmsize
  int shmsize = ((fnsize/2880)+1)*2880;

  // get shmid
  int key;
  istrstream str(argv[1]);
  str >> key;

  //  key_t key = ftok("/home/joye/.profile",keykey);
  //  cerr << "key " << key << endl;
  
  // first see if it alread exists
  int shmid = shmget(key, shmsize, 0);

  if (shmid < 0) {
    // now try to create it
    shmid = shmget(key, shmsize, IPC_CREAT|0666);

    if (shmid < 0) {
      // give up, its bad
      perror("shmid is bad");
      exit(1);
    }
  }
  cerr << "shmid " << shmid << endl;

  // get shm stats
  struct shmid_ds sbuf;
  if (shmctl(shmid, IPC_STAT, &sbuf)<0) {
    perror("shmctl is bad");
    exit(1);
  }
  cerr << "size of shared segment: " << sbuf.shm_segsz << endl;

  char* addr = (char*)shmat(shmid, NULL, 0);
  if ((int)addr == -1){
    perror("shmat failed");
    exit(1);
  }

  // load image
  ifstream fd(fn);
  fd.read(addr,fnsize);
  cerr << fd.gcount() << " bytes read" << endl;
  if (fd.gcount() != fnsize)
    cerr << "File read error" << endl;
  else 
    cerr << "success!" << endl;
}

