#ifndef __basebox_h__
#define __basebox_h__

#include "basemarker.h"

class BaseBox : public BaseMarker {
protected:
  Vector* size;
  double angle;
  Matrix flip;

  void calcPoints(double);
  virtual void updateHandles() {}

public:
  BaseBox(Frame* p, const Vector& ctr, double a,
	  const char* clr,  const char* f, const char* t, unsigned short prop);
  virtual ~BaseBox();

  void updateCoords(Matrix&);
  virtual void editBegin(int) =0;
  virtual void edit(const Vector&, int) =0;
  virtual void editEnd() =0;
  void rotate(const Vector&, int);
  int isIn(const Vector&);

  double getAngle() {return angle;}
  void setAngle(double);

  virtual void list(ostream&, int, int, const char*) =0;
  virtual void listCiao(ostream&, int, int, const char*) {}
  virtual void listFtools(ostream&, int, int, const char*) {}
  virtual void listSAOimage(ostream&, const char*) =0;
  virtual void listPros(ostream&, int, int, const char*) {}
};

#endif
