#ifndef __fvcontour_h__
#define __fvcontour_h__

#include "vector.h"
#include "contour.h"

class FVContourPlot : public ContourPlot {
private:
  enum {top, right, bottom, left, none};

  ContourScale* scale;
  float resolution;
  int method;

  void unity(FitsImage*);
  void bin(FitsImage*);
  int build(int xdim, int ydim, float *image, Matrix&);
  int trace(int xdim, int ydim, float cntr,
	    int xCell, int yCell, int side,
	    float** rows, char* useGrid, Matrix&);

public:
  FVContourPlot(Frame*, FitsImage*, const char*, int, float, int, float, float,
		Frame::ColorScaleType);
  FVContourPlot(Frame*, FitsImage*, const char*, int, float, int, float*);
  ~FVContourPlot();

  void append(FitsImage*);
  int getMethod() {return method;}
};

#endif
