#ifndef __util_h__
#define __util_h__

#include <iostream.h>

#ifndef _WIN32
#define XWARPPOINTER XWarpPointer
#define XGETIMAGE XGetImage
#else
#include <xxlib.h>
#define XWARPPOINTER XXWarpPointer
#define XGETIMAGE XXGetImage
#endif

extern int lsb();

void swap2(char* src, char* dest);
void swap4(char* src, char* dest);
void swap8(char* src, char* dest);

extern char* dupstr(const char*);
extern char* toLower(const char*);
extern char* toUpper(const char*);

extern double degToRad(double);
extern double radToDeg(double);
extern double hmsToDegree(int, double, double, double);
extern double dmsToDegree(int, double, double, double);
extern double parseDMS(const char*);

extern unsigned char decodeMask(unsigned char, int*);
extern unsigned short decodeMask(unsigned short, int*);
extern int decodeMask(unsigned long);

extern double RGB2Gray(double, double, double);
extern unsigned char RGB2Gray(unsigned char, unsigned char, unsigned char);
extern void RGB2CMYK(unsigned char, unsigned char, unsigned char,
		     unsigned char*, unsigned char*, unsigned char*, 
		     unsigned char*);
extern ostream& psColorGray(const char*, ostream&);
extern ostream& psColorRGB(const char*, ostream&);
extern ostream& psColorCMYK(const char*, ostream&);

extern char* psQuote(const char*);

extern int fCompare(const void*, const void*);
extern int dCompare(const void*, const void*);

#endif
